import json
from os import listdir
from os.path import isfile, join
import sys
import re

SCRIPT_VERSION = 1

# script to pull interesting data out of sudoers files

def ParseSudoersFile(filepath, defaults, users, groups):
    with open(filepath, 'rt') as f:
        for entry in f.readlines():
            entry = entry.lstrip().rstrip('\n')
            if entry.startswith('#'):
                continue
            elif entry.lower().startswith('defaults'):
                tokens = re.split('\s+',entry, 1)
                if len(tokens) > 0:
                    defaults.append(tokens[1])
            elif entry.startswith('%'):
                tokens = entry.split()
                if len(tokens) > 0:
                    groups.append(tokens[0][1:])
            else:
                tokens = entry.split()
                if len(tokens) > 0:
                    users.append(tokens[0])
    return defaults, users, groups

sudoers_file = '/etc/sudoers'
sudoers_dir = '/etc/sudoers.d'

defaults, users, groups = ParseSudoersFile(sudoers_file,[],[],[])
for filename in listdir(sudoers_dir):
    path = join(sudoers_dir, filename)
    if not isfile(path):
        continue
    defaults, users, groups = ParseSudoersFile(path, defaults, users, groups)

def ConstructOutput(defaults, users, groups):
    return {
        'scriptVersion' : SCRIPT_VERSION,
        'defaults' : defaults,
        'users' : users,
        'groups' : groups
    }
    
output = ConstructOutput(defaults, users, groups)
sys.stdout.write(json.dumps(output))
